/// <reference types="node" />
import { Closeable, Deferred, Demultiplexer, DuplexConnection, Frame, FrameHandler, Multiplexer, Outbound } from "rsocket-core";
import { Duplex } from "stream";
export declare class WebsocketDuplexConnection extends Deferred implements DuplexConnection, Outbound {
    private websocketDuplex;
    readonly multiplexerDemultiplexer: Multiplexer & Demultiplexer & FrameHandler;
    constructor(websocketDuplex: Duplex, frame: Frame, multiplexerDemultiplexerFactory: (frame: Frame, outbound: Outbound & Closeable) => Multiplexer & Demultiplexer & FrameHandler);
    get availability(): number;
    close(error?: Error): void;
    send(frame: Frame): void;
    private handleClosed;
    private handleError;
    private handleMessage;
    static create(socket: Duplex, connectionAcceptor: (frame: Frame, connection: DuplexConnection) => Promise<void>, multiplexerDemultiplexerFactory: (frame: Frame, outbound: Outbound & Closeable) => Multiplexer & Demultiplexer & FrameHandler): void;
}
