"use strict";
/*
 * Copyright 2021-2022 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WebsocketDuplexConnection = void 0;
var rsocket_core_1 = require("rsocket-core");
var WebsocketDuplexConnection = /** @class */ (function (_super) {
    __extends(WebsocketDuplexConnection, _super);
    function WebsocketDuplexConnection(websocketDuplex, frame, multiplexerDemultiplexerFactory) {
        var _this = _super.call(this) || this;
        _this.websocketDuplex = websocketDuplex;
        _this.handleClosed = function (e) {
            _this.close(new Error(e.reason || "WebsocketDuplexConnection: Socket closed unexpectedly."));
        };
        _this.handleError = function (e) {
            _this.close(e.error);
        };
        _this.handleMessage = function (buffer) {
            try {
                var frame = 
                /* this._options.lengthPrefixedFrames
                  ? deserializeFrameWithLength(buffer, this._encoders)
                  :  */ (0, rsocket_core_1.deserializeFrame)(buffer);
                // if (__DEV__) {
                //   if (this._options.debug) {
                //     console.log(printFrame(frame));
                //   }
                // }
                _this.multiplexerDemultiplexer.handle(frame);
            }
            catch (error) {
                _this.close(error);
            }
        };
        websocketDuplex.on("close", _this.handleClosed);
        websocketDuplex.on("error", _this.handleError);
        websocketDuplex.on("data", _this.handleMessage);
        _this.multiplexerDemultiplexer = multiplexerDemultiplexerFactory(frame, _this);
        return _this;
    }
    Object.defineProperty(WebsocketDuplexConnection.prototype, "availability", {
        get: function () {
            return this.websocketDuplex.destroyed ? 0 : 1;
        },
        enumerable: false,
        configurable: true
    });
    WebsocketDuplexConnection.prototype.close = function (error) {
        if (this.done) {
            _super.prototype.close.call(this, error);
            return;
        }
        this.websocketDuplex.removeAllListeners();
        this.websocketDuplex.end();
        delete this.websocketDuplex;
        _super.prototype.close.call(this, error);
    };
    WebsocketDuplexConnection.prototype.send = function (frame) {
        if (this.done) {
            return;
        }
        //   if (__DEV__) {
        //     if (this._options.debug) {
        //       console.log(printFrame(frame));
        //     }
        //   }
        var buffer = 
        /* this._options.lengthPrefixedFrames
            ? serializeFrameWithLength(frame, this._encoders)
            :*/ (0, rsocket_core_1.serializeFrame)(frame);
        // if (!this._socket) {
        //   throw new Error(
        //     "RSocketWebSocketClient: Cannot send frame, not connected."
        //   );
        // }
        this.websocketDuplex.write(buffer);
    };
    WebsocketDuplexConnection.create = function (socket, connectionAcceptor, multiplexerDemultiplexerFactory) {
        var _this = this;
        // TODO: timeout on no data?
        socket.once("data", function (buffer) { return __awaiter(_this, void 0, void 0, function () {
            var frame, connection, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        frame = (0, rsocket_core_1.deserializeFrame)(buffer);
                        connection = new WebsocketDuplexConnection(socket, frame, multiplexerDemultiplexerFactory);
                        if (connection.done) {
                            return [2 /*return*/];
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        socket.pause();
                        return [4 /*yield*/, connectionAcceptor(frame, connection)];
                    case 2:
                        _a.sent();
                        socket.resume();
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _a.sent();
                        connection.close(error_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
    };
    return WebsocketDuplexConnection;
}(rsocket_core_1.Deferred));
exports.WebsocketDuplexConnection = WebsocketDuplexConnection;
//# sourceMappingURL=WebsocketDuplexConnection.js.map