import { Closeable, Demultiplexer, DuplexConnection, Frame, FrameHandler, Multiplexer, Outbound, ServerTransport } from "rsocket-core";
import { Server } from "ws";
export declare type SocketFactory = (options: SocketOptions) => Server;
export declare type SocketOptions = {
    host?: string;
    port?: number;
};
export declare type ServerOptions = SocketOptions & {
    wsCreator?: SocketFactory;
    debug?: boolean;
};
export declare class WebsocketServerTransport implements ServerTransport {
    private readonly host;
    private readonly port;
    private readonly factory;
    constructor(options: ServerOptions);
    bind(connectionAcceptor: (frame: Frame, connection: DuplexConnection) => Promise<void>, multiplexerDemultiplexerFactory: (frame: Frame, outbound: Outbound & Closeable) => Multiplexer & Demultiplexer & FrameHandler): Promise<Closeable>;
    private connectServer;
}
